/*    Assignment-1              */
/*    Name - Prabhat Pandey     */
/*    Part - C                  */
/*    Roll NO.- 10498           */
/*    Dept. - CSE               */



#include<stdio.h>
#include<stdlib.h>
#include<time.h>


int valid(int move, int x, int y)                                        //to find walls
{
   switch(move)
   {
       case 0: { if(x==0) return 0;
                   return 1;
               }
                  
       case 1: { if(y==0) return 0;
                   return 1;
               }

       case 2: { if(x==7) return 0;
                   return 1;
               }

       case 3: { if(y==4) return 0;
                   return 1; 
               }
    }
}





int main()
{

   FILE *ip, *op;
   int i, j, k, x, y, move, row, column, pole;
   int total_moves=0, no_of_moves, flag[4], random[4], visited[4];
   float neighbour[4], max=-1.0, total_dirt;
   char str[4][10];
   int N=30;

   ip = fopen("environ.txt", "r");
   op = fopen("prabhatp_hw1cOut.txt", "w");

   fscanf(ip,"%s",str[0]);
   fscanf(ip,"%d",&row);
   fscanf(ip,"%d",&column);

   float dirt[row][column];
   int grid[row][column];

   fscanf(ip,"%s",str[1]);

   for (i=0;i<row;i++)
   {
      for (j=0;j<column;j++)
      {
         fscanf(ip,"%f",&dirt[i][j]);  
         grid[i][j] = 0;
      }        
   }

   fscanf(ip,"%s",str[2]);
   fscanf(ip,"%d",&no_of_moves);
   fscanf(ip,"%s",str[3]);
   fscanf(ip,"%d",&x);
   fscanf(ip,"%d",&y);

   x = x-1;
   y = y-1;

   while (total_moves < no_of_moves)
   {

      for (i=0;i<4;i++)
      {
         random[i] = 0;    
         flag[i] = 0;
         visited[i] = 0;
      }
    
      if (dirt[x][y] != 0)                                                  //current square is dirty
      {
         total_dirt = total_dirt + dirt[x][y];
         dirt[x][y] = 0;   
         grid[x][y] = 1;      
         total_moves++;
         fprintf(op, "S %f\n", total_dirt);
      }

      else
      {
 
         if (valid(0,x,y))
         {
            flag[0] = 1;
            neighbour[0] = dirt[x-1][y];
            if (grid[x-1][y])
               visited[0]++;
         }

         if (valid(1,x,y))
         {
            flag[1] = 1;
            neighbour[1] = dirt[x][y-1];
            if (grid[x][y-1])
               visited[1]++;
         }

         if (valid(2,x,y))
         {
            flag[2] = 1;
            neighbour[2] = dirt[x+1][y];
            if (grid[x+1][y])
               visited[2]++;
         }

         if (valid(3,x,y))
         {
            flag[3] = 1;
            neighbour[3] = dirt[x][y+1];
            if (grid[x][y+1])
               visited[3]++;
         }

         max = -1;

         for (i=0;i<4;i++)                                                 //finding most dirty neighbour
         {
            if (flag[i])
            {
               if (max == -1.0)
               {
                  max = neighbour[i];
                  move = i;
               }
               else
               {
                  if (neighbour[i] > max)
                  {
                     max = neighbour[i];
                     move = i;
                     for (k=i-1;k>=0;k--)
                        random[k] = 0;
                  } 
                  else if (neighbour[i] == max)                           //when two or more neighbours are equally dirty   
                  {
                     if (!visited[i])                                     //don't move to cleaned square
                     {
                        random[move] = 1;
                        random[i] = 1;
                     }
                  }  
              }
             }
          }

          j = 0;
          k = 0;
          pole = 0;

          for (i=0;i<4;i++)
          {
             if (random[i])
                j++;
          }

          if (j)                                                          //when two or more neighbours are equally dirty   
          {

             srand((int) time(NULL));
             move = rand() % j;
             move = move < 0?-move:move;

             for(i=0;i<4;i++)
             {
                if (random[i])
                {
                   if(k == move)
                   {
                      move = i;
                      pole++;
                   }
                   else
                      k++;
                }

                if (pole)
                   break;
              }

          }



          switch (move)
          {
             case 0:{ 
                       x = x-1;
                       fprintf(op, "U %f\n", total_dirt);
                       total_moves++;
                       break;
                     }
             case 1: { 
                       y = y-1;
                       fprintf(op, "L %f\n", total_dirt);
                       total_moves++;
                       break;
                     }                      
             case 2: { 
                       x = x+1;
                       fprintf(op, "D %f\n", total_dirt);
                       total_moves++;
                       break; 
                     }
             case 3: {
                       y = y+1;
                       fprintf(op, "R %f\n", total_dirt);
                       total_moves++;
                       break; 
                     }
          }

      }

      if ((total_moves % N) == 0)
      {

         for(i=0;i<row;i++)
         {

            for(j=0;j<column;j++)
            {
               if ( (i==x) && (j==y) )
               {
                 fprintf(op, "[%f]\t", dirt[i][j]);
               }
               else
               {
                 fprintf(op, "%f\t", dirt[i][j]);
               }
            }
    
            fprintf(op, "\n");
         }    

      } 

   }


   fclose(ip);
   fclose(op);

}
